#include <SDL2/SDL.h>
#include <stdio.h>

#include "src/export.h"
#include "src/input.h"
#include "src/draw.h"
#include "src/global.h"

void initSDL() {
  SDL_Init(SDL_INIT_VIDEO);
  window = SDL_CreateWindow(
    "pixed",
    SDL_WINDOWPOS_UNDEFINED,
    SDL_WINDOWPOS_UNDEFINED,
    SCREEN_WIDTH,
    SCREEN_HEIGHT,
    SDL_WINDOW_SHOWN
  );
  renderer = SDL_CreateRenderer(window, -1, SDL_RENDERER_ACCELERATED);
  SDL_SetRenderDrawColor(renderer, 0, 0, 0, 255);
  SDL_RenderClear(renderer);
  SDL_RenderPresent(renderer);
}

int main(void) {
  initSDL();

  while (1) {
    handleInput();
    drawGrid();
    SDL_Delay(16);
  }

  return 0;
}
