#include <SDL2/SDL.h>

#include "global.h"

void doDrawGrid(int x, int y) {
  SDL_Rect pixelRect = {
    x * PIXEL_SIZE,
    y * PIXEL_SIZE,
    PIXEL_SIZE,
    PIXEL_SIZE
  };
  SDL_SetRenderDrawColor(renderer, 200, 200, 200, 255);

  if (grid[x][y] == 0) {
    SDL_SetRenderDrawColor(renderer, 255, 255, 255, 255);
  } else if (grid[x][y] == 1) {
    SDL_SetRenderDrawColor(renderer, 255, 0, 0, 255);
  } else if (grid[x][y] == 2) {
    SDL_SetRenderDrawColor(renderer, 0, 255, 0, 255);
  } else if (grid[x][y] == 3) {
    SDL_SetRenderDrawColor(renderer, 0, 0, 255, 255);
  } else {
    SDL_SetRenderDrawColor(renderer, 0, 0, 0, 255);
  }

  SDL_RenderFillRect(renderer, &pixelRect);
}

void drawPicker() {
  SDL_Rect pickerRect = {
    FRAME_WIDTH,
    0,
    COLOR_PICKER_WIDTH,
    SCREEN_HEIGHT
  };

  SDL_SetRenderDrawColor(renderer, 100, 100, 100, 255);
  SDL_RenderFillRect(renderer, &pickerRect);

  SDL_Rect colorRect = {
    FRAME_WIDTH + PIXEL_SIZE,
    COLOR_PICKER_WIDTH / 4,
    COLOR_PICKER_WIDTH - (PIXEL_SIZE * 2),
    COLOR_PICKER_WIDTH / 4 - PIXEL_SIZE
  };

  SDL_SetRenderDrawColor(renderer, 255, 0, 255, 255);
  SDL_RenderFillRect(renderer, &colorRect);
}

void drawGrid() {
  SDL_SetRenderDrawColor(renderer, 255, 255, 255, 255);
  SDL_RenderClear(renderer);

  for (int x = 0; x < FRAME_WIDTH / PIXEL_SIZE; x++) {
    for (int y = 0; y < FRAME_HEIGHT / PIXEL_SIZE; y++) {
      doDrawGrid(x, y);
    }
  }

  drawPicker();
  SDL_RenderPresent(renderer);
}
