#include <stdio.h>

#include "global.h"

void saveTGA() {
  FILE *file = fopen("sprite.tga", "wb");
  if (!file) {
    puts("ファイルの作成に失敗。\n");
    return;
  }

  fputc(0, file); // ID長さ
  fputc(0, file); // 色マップ類
  fputc(2, file);
  for (int i = 0; i < 5; i++) fputc(0, file);
  for (int i = 0; i < 4; i++) fputc(0, file);
  fputc(FRAME_WIDTH & 0xFF, file);
  fputc((FRAME_WIDTH >> 8) & 0xFF, file);
  fputc(FRAME_HEIGHT & 0xFF, file);
  fputc((FRAME_HEIGHT >> 8) & 0xFF, file);
  fputc(24, file);

  for (int y = FRAME_HEIGHT / PIXEL_SIZE - 1; y >= 0; y--) {
    for (int x = 0; x < FRAME_WIDTH / PIXEL_SIZE; x++) {
      int color = grid[x][y];
      if (color == 0) {
        fputc(0, file);
        fputc(0, file);
        fputc(0, file);
      } else if (color == 1) {
        fputc(255, file);
        fputc(0, file);
        fputc(0, file);
      } else if (color == 2) {
        fputc(0, file);
        fputc(255, file);
        fputc(0, file);
      } else if (color == 3) {
        fputc(0, file);
        fputc(0, file);
        fputc(255, file);
      } else {
        fputc(255, file);
        fputc(255, file);
        fputc(255, file);
      }
    }
  }

  fclose(file);
  puts("ファイルを保存しました。");
}
